#ifndef AVICAP_RENDERER_H
#define AVICAP_RENDERER_H

#include "avm_stl.h"
#include "image.h"
#include "subtitle.h"
#include "renderer.h"
#include "playerwidget.h"
#include "../../lib/aviplay/aviplay_impl.h"
#include <videodecoder.h>
#include <aviplay.h>
#include <avifile.h>
#include <creators.h>
using namespace Creators;

#include "capproc.h"
#include "v4lwindow.h"

class V4LWindow;

AVM_BEGIN_NAMESPACE;

class AvicapRenderer : public AviPlayer , public IPlayerWidget {
//class AvicapRenderer : public IPlayerWidget {
    IPlayerWidget* m_pPW;
    void* m_pDpy;
    //int m_iResizeCount;
    int zx, zy, zw, zh;
    Colorspaces recording_csp;
    V4LWindow *v4lw;
 public:
  AvicapRenderer(void *dpy);
  virtual ~AvicapRenderer();
  virtual void createVideoRenderer();
  virtual int Refresh();
  virtual int Resize(int& new_w, int& new_h);
  virtual int Zoom(int x, int y, int w, int h);
  virtual void PW_resize(int w, int h) { Resize(w,h); } // resize event
  virtual void PW_menu_slot() { v4lw->avicap_renderer_popup(); }

  virtual int ToggleFullscreen(bool maximize=false);
  void updateResize();
  bool checkColorSpace(fourcc_t csp);
  int drawFrame(avm::CImage* im);
  void setSize(int w,int h);
  void setV4LWindow(V4LWindow *v4lwindow) { v4lw=v4lwindow; };

  //  void PopupMenu();

  void setRecordingColorSpace(Colorspaces colorspace);

};

AVM_END_NAMESPACE;

#endif  // AVICAP_RENDERER_H
